<template>
	<div class="FieldsViewRecentActivityFilter">
		<div class="FieldsViewRecentActivityFilter-header">
			<h4>Filter by Recent Activity</h4>
			<template v-if="!useDesktopLayout">
				<v-spacer></v-spacer>
				<button class="FieldsViewRecentActivityFilter-clear primary--text" @click="clearFilter">Clear filter</button>
			</template>
		</div>
		<v-divider></v-divider>
		<v-radio-group @change="handleRadioChange" :value="currentRadioValue">
			<v-radio v-for="days in commonlyUsedOptions" :key="`input-${days}`" :value="days" :label="`Last ${days} days`">
			</v-radio>
			<v-radio key="input-custom" value="custom" label="Custom date range"> </v-radio>
		</v-radio-group>
		<div v-if="isCustom" class="FieldsViewRecentActivityFilter-custom">
			<v-divider></v-divider>
			<div class="FieldsViewRecentActivityFilter-controlGroup">
				<div class="FieldsViewRecentActivityFilter-dateControl">
					<label for="recentActivityFilterCustomStart">From:</label>
					<input
						type="date"
						id="recentActivityFilterCustomStart"
						:value="dateToInputValue(recentActivityFilter.start)"
						@change="handleCustomDateChange"
					/>
				</div>
				<div class="FieldsViewRecentActivityFilter-dateControl">
					<label for="recentActivityFilterCustomEnd">To:</label>
					<input
						type="date"
						id="recentActivityFilterCustomEnd"
						:value="dateToInputValue(recentActivityFilter.end)"
						@change="handleCustomDateChange"
					/>
				</div>
			</div>
		</div>
		<template v-if="useDesktopLayout">
			<v-divider></v-divider>
			<div class="FieldsViewRecentActivityFilter-footer">
				<button class="FieldsViewRecentActivityFilter-clear primary--text" @click="clearFilter">Clear filter</button>
				<button class="FieldsViewRecentActivityFilter-ok primary--text" @click="$emit('ok')">OK</button>
			</div>
		</template>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from '@vue/composition-api';

const millisecondsPerDay = 24 * 60 * 60 * 1000;
const commonlyUsedOptions = [7, 30, 90];
const getBeginningOfDay = () => new Date(new Date().setHours(0, 0, 0, 0));
const getBeginningOfYear = () => {
	const date = getBeginningOfDay();
	date.setMonth(0, 1);
	return date;
};

const getXDaysAgo = (days: number) => {
	const beginningOfToday = getBeginningOfDay();
	return new Date(beginningOfToday.getTime() - days * millisecondsPerDay);
};

export default defineComponent({
	emits: ['ok'],
	props: {
		useDesktopLayout: {
			type: Boolean,
			default: false,
		},
	},
	setup(_, { root }) {
		const isCustom = ref(false);
		const recentActivityFilter = computed(() => root.$store.getters['fieldsView/getRecentActivityFilter']);
		const getInitialCurrentValue = () => {
			const { start, end } = recentActivityFilter.value;
			if (start === null && end === null) {
				return null;
			}
			const startTime = start?.getTime();
			const endTime = end?.getTime();
			const beginningOfTodayTime = getBeginningOfDay().getTime();
			const commonlyUsedOptionsDates = commonlyUsedOptions.map(getXDaysAgo);
			if (startTime === commonlyUsedOptionsDates[0].getTime() && endTime === beginningOfTodayTime) {
				return commonlyUsedOptions[0];
			}
			if (startTime === commonlyUsedOptionsDates[1].getTime() && endTime === beginningOfTodayTime) {
				return commonlyUsedOptions[1];
			}
			if (startTime === commonlyUsedOptionsDates[2].getTime() && endTime === beginningOfTodayTime) {
				return commonlyUsedOptions[2];
			}
			return 'custom';
		};
		const currentRadioValue = computed(getInitialCurrentValue);

		const setRecentActivityFilter = (recentActivityFilter: { start: Date | null; end: Date | null }) => {
			root.$store.dispatch('fieldsView/setRecentActivityFilter', recentActivityFilter);
		};

		const clearFilter = () => {
			setRecentActivityFilter({ start: null, end: null });
			isCustom.value = false;
		};

		const setFilterToLastXDays = (days: number) => {
			const beginningOfToday = getBeginningOfDay();
			setRecentActivityFilter({
				start: getXDaysAgo(days),
				end: beginningOfToday,
			});
		};

		const dateToInputValue = (date: Date | null) => (date !== null ? date.toISOString().split('T')[0] : '');

		const handleRadioChange = (value: any) => {
			if (value === 'custom') {
				isCustom.value = true;
				const beginningOfToday = getBeginningOfDay();
				const beginningOfYear = getBeginningOfYear();
				// both start and end must be specified as valid dates as iOS Safari does not render anything when the input's value is empty
				setRecentActivityFilter({ start: beginningOfYear, end: beginningOfToday });
			} else {
				isCustom.value = false;
				const days = parseInt(value, 10);
				setFilterToLastXDays(days);
			}
		};

		const handleCustomDateChange = (event: any) => {
			if (event.target.id === 'recentActivityFilterCustomStart') {
				setRecentActivityFilter({
					start: event.target.value ? new Date(event.target.value) : null,
					end: recentActivityFilter.value.end,
				});
			}
			if (event.target.id === 'recentActivityFilterCustomEnd') {
				setRecentActivityFilter({
					start: recentActivityFilter.value.start,
					end: event.target.value ? new Date(event.target.value) : null,
				});
			}
		};

		return {
			commonlyUsedOptions,
			recentActivityFilter,
			handleRadioChange,
			handleCustomDateChange,
			clearFilter,
			isCustom,
			dateToInputValue,
			currentRadioValue,
		};
	},
});
</script>

<style>
.FieldsViewRecentActivityFilter {
	padding: 6px 8px;
	background: #fff;
}

.FieldsViewRecentActivityFilter-header {
	display: flex;
}

.FieldsViewRecentActivityFilter .v-input--radio-group {
	margin-top: 0;
}

.FieldsViewRecentActivityFilter .v-input--radio-group .v-messages {
	display: none;
}

.FieldsViewRecentActivityFilter .v-divider {
	margin: 4px 0 8px 0;
}

.FieldsViewRecentActivityFilter-dateControl {
	display: flex;
	flex-direction: column;
}

.FieldsViewRecentActivityFilter-controlGroup {
	display: flex;
}

.FieldsViewRecentActivityFilter-dateControl:last-of-type {
	margin-left: 8px;
}

.FieldsViewRecentActivityFilter-dateControl input {
	color: rgba(0, 0, 0, 0.6);
}

.FieldsViewRecentActivityFilter-dateControl label {
	color: rgba(0, 0, 0, 0.6);
}

.FieldsViewRecentActivityFilter-footer {
	display: flex;
	justify-content: space-between;
}
</style>
